// -*- c++ -*-
/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2007 by The Mico Team
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  For more information, visit the MICO Home Page at
 *  http://www.mico.org/
 */

#ifndef __mico_transport_tcp_h__
#define __mico_transport_tcp_h__

namespace MICO {

class TCPTransport : public SocketTransport {

    InetAddress local_addr, peer_addr;

public:
    MICO_EXPORT virtual ~TCPTransport ();
    MICO_EXPORT CORBA::Boolean bind (const CORBA::Address *);
    MICO_EXPORT CORBA::Boolean connect (const CORBA::Address *, CORBA::ULong, CORBA::Boolean&);

    MICO_EXPORT void open (CORBA::Long fd = -1);
    MICO_EXPORT void close ();
    
    MICO_EXPORT CORBA::Long read (void *, CORBA::Long len);
    MICO_EXPORT CORBA::Long write (const void *, CORBA::Long len);
    
    MICO_EXPORT const CORBA::Address *addr ();
    MICO_EXPORT const CORBA::Address *peer ();
    
};

class TCPTransportServer: public SocketTransportServer {

    InetAddress local_addr;
public:
    MICO_EXPORT TCPTransportServer ();

    MICO_EXPORT CORBA::Boolean bind (const CORBA::Address *);
    MICO_EXPORT void close ();
    
    MICO_EXPORT CORBA::Transport *accept ();
    MICO_EXPORT const CORBA::Address *addr ();

    MICO_EXPORT void listen ();    
};

}

#endif // __mico_transport_tcp_h__
